const login = () => {
  const app = getApp()
  let mingUserId = dd.getStorageSync({ key: 'mingUserId' }).data
  let username = dd.getStorageSync({ key: 'username' }).data
  // 有token
  if(dd.getStorageSync({ key: 'token' }).data && dd.getStorageSync({ key: 'token' }).data.access_token) {
    let hasToken = dd.getStorageSync({ key: 'token' }).data; // token
    let expires_in = hasToken.expires_in || ''; // 过期时效
    let loginTime = hasToken.loginTime || ''; // 用户登陆时间
    let token = hasToken.access_token || '';
    let refresh_token = hasToken.refresh_token // 刷新token
    // 判断token没有过期
    if(new Date().getTime() - hasToken.loginTime < (hasToken.expires_in - 300) * 1000) {
      // if(((new Date()).getTime() - hasToken.loginTime < 30 * 1000)) {
      dd.hideLoading()
      dd.redirectTo({
        url:'/pages/index/index'
      })
    }
    // 判断token过期
    else {
      return new Promise((resolve,reject) => {
        // 判断有无网络
         dd.getNetworkType({
           success: (res) => {
             if(res.networkAvailable) {
                dd.httpRequest({
                  headers: {
                    'Authorization': 'Basic bWluZ3BheS1waG9uZTptaW5ncGF5LXBob25l',
                    'Content-Type': 'application/x-www-form-urlencoded'
                  },
                  dataType: 'json',
                  data: {
                    grant_type: 'refresh_token',
                    refresh_token: refresh_token
                  },
                  url:`${app.globalData.globalUrl}/auth/oauth/token`,
                  method: 'POST',
                  success: function(res) {
                    if(res.status == 200) {
                      dd.setStorageSync({
                        key: 'token',
                        data: {
                          access_token: res.data.access_token,
                          expires_in: res.data.expires_in,
                          refresh_token: res.data.refresh_token,
                          loginTime: (new Date()).getTime()
                        }
                      })
                      dd.hideLoading()
                      login()
                    }
                  },
                  fail: function(err) {
                    if(err.status == 426) {
                      dd.removeStorageSync({
                        key: 'token'
                      })
                    dd.hideLoading()
                    login()
                    }
                    else {
                      dd.hideLoading()
                      dd.removeStorageSync({key:'token'})
                      dd.redirectTo({
                        url: '/pages/reTry/reTry'
                      })
                    }
                  }
                })
             }
             else {
              dd.hideLoading()
              dd.removeStorageSync({key:'token'})
               dd.redirectTo({
                  url: '/pages/reTry/reTry'
                })
             }
           }
         })
      })
    }
  }
  // 无token
  else {
    return new Promise((resolve,reject) => {
      dd.getNetworkType({
        success: function(res) {
          if(res.networkAvailable) {
            dd.httpRequest({
              headers: {
               'Authorization': 'Basic bWluZ3BheS1waG9uZTptaW5ncGF5LXBob25l',
               'Content-Type': 'application/x-www-form-urlencoded'
              },
              data: {
                username: username,
                password: username,
                scope: 'server',
                grant_type: 'password'
              },
              url:`${app.globalData.globalUrl}/auth/oauth/token`,
              method: 'POST',
              dataType: 'json',
              success: function(res) {
                dd.setStorageSync({
                  key: 'token',
                  data: {
                    access_token: res.data.access_token,
                    expires_in: res.data.expires_in,
                    refresh_token: res.data.refresh_token,
                    loginTime: (new Date()).getTime()
                  }
                })
                dd.hideLoading()
                dd.redirectTo({
                  url:'/pages/index/index'
                })
              }
            })
          }
          else {
            dd.hideLoading()
            dd.redirectTo({
              url:'/pages/reTry/reTry'
            })
          }
        }
      })
    })
    

  }
}
export default {login}