const app = getApp()
import $http from './../../API/http'
Page({
  data:{
    type: '1',
    available: 'YES',
    dataList:[],
    currentPage: 1,
    pageNumber: 10,
    totalCount: ''
    
  },
  onLoad(query) {
    dd.setNavigationBar({title: '津贴列表'});
  },
  onReady() {
    this.querySubsidyList()
    this.resetData()
  },
  resetData(){
    this.setData({
      type: '1',
      available: 'YES',
      dataList:[],
      currentPage: 1,
      pageNumber: 10,
      totalCount: ''
    })
  },
  endTimeToStr (time) {
    time = time.replace(/\-/g, "/")
    let timeData = new Date(time)
    let year = timeData.getFullYear()
    let month = timeData.getMonth() + 1
    let date = timeData.getDate()
    let hour = timeData.getHours()
    let minute = timeData.getMinutes()
    return `${year}年${month.toString().length > 1 ? month : '0' + month}月${date.toString().length > 1 ? date : '0' + date}日${hour.toString().length > 1 ? hour : '0' + hour}:${minute.toString().length > 1 ? minute : '0' + minute}`

  },
  changeType(event) {
    this.setData({
      type: event.target.dataset.type,
      available: event.target.dataset.available,
      dataList: []
    })
    this.querySubsidyList()
  },
  querySubsidyList(str) {
    const _that = this;
    console.log(str)
    let data = {
      currentPage: this.data.currentPage,
      pageNumber: this.data.pageNumber,
      available: this.data.available,
      ddUserId: dd.getStorageSync({ key: 'userId' }).data
    }
    $http.$http('/mingpay-phone/v1/isv/account/query_subsidyList_by_user_id', data, 'GET').then((res) => {
      let dataList = [...res.recordList];
      let dataListSource = _that.data.dataList;
      if (dataList.length > 0) {
        dataList.map((item, index) => {
          item.endTime = _that.endTimeToStr(item.endTime);
          dataListSource.push(item)
        })
        let totalCount = Math.ceil(parseInt(res.totalCount)/_that.data.pageNumber)
        _that.setData({
          dataList: dataListSource,
          totalCount: totalCount
        })
        dd.hideLoading();
      } else {
        _that.setData({
          dataList: [],
          totalCount: 1
        })
        dd.hideLoading();
      }  
    }).catch((res) => {
      console.log(res)
    })
  },
  toAllowanceRecordList(event) {
    dd.navigateTo({url:`./../allowanceRecordList/allowanceRecordList?subsidyNo=${event.target.dataset.subsidyNo}`})
  },
  onShow() {
    // 页面显示
  },
  onHide() {
    // 页面隐藏
  },
  onUnload() {
    // 页面被关闭
   
  },
  onTitleClick() {
    // 标题被点击
  },
  onPullDownRefresh() {
    // 页面被下拉
    const _that = this
    _that.setData({
      type: '1',
      available: 'YES',
      dataList:[],
      currentPage: 1,
      pageNumber: 10,
      totalCount: ''
    })
    this.querySubsidyList()
    // this.resetData()
    dd.stopPullDownRefresh()
  },
  onReachBottom() {
    let currentNum = '';
    if (this.data.currentPage < this.data.totalCount) {
      currentNum = this.data.currentPage + 1
      this.setData({
        currentPage: currentNum
      })
      this.querySubsidyList(currentNum)
    }
  },
  onShareAppMessage() {
    // 返回自定义分享信息
    return {
      title: 'My App',
      desc: 'My App description',
      path: 'pages/index/index',
    };
  },
});
