const app = getApp()
import $http from './../../API/http';
import create from 'dd-store';
import exampleStore from '/stores/exampleStore';
create.Page({
  store: exampleStore,
  useAll: true,
  data: {
    typeHistory: '1',
    dataHistoryList: [],
    currentPage: 1,
    pageSize: 10,
    totalCount: '',
    select: '',
    recordId: '',
    index: '',
    value: '',
    isNull: true
  },
  changeType(event) {
    this.setData({
      typeHistory: event.target.dataset.type,
      dataHistoryList: [],
      currentPage: 1
    })
    this.visitorList(this.data.typeHistory)
  },
  visitorList(type) {
    const _that = this
    let data = {
      currentPage: this.data.currentPage,
      pageSize: this.data.pageSize,
      type: type,
      visitorName: _that.data.value
    }
    $http.$http('/admin/visitor/getRecordList', data, 'post').then(res => {
      let dataList = res.records;
      let dataListSource = _that.data.dataHistoryList;
      if (dataList.length > 0) {
        dataList.forEach((item, index) => {
          if (new Date(item.endTime.replace(/\-/g, "/")).getTime() < new Date().getTime()) {
            item.overdue = true
          }
          else {
            item.overdue = false
          }
          if (new Date(item.endTime.replace(/\-/g, "/")).getTime() - new Date(item.startTime.replace(/\-/g, "/")).getTime() < 24 * 60 * 60 * 3 * 1000) {
            item.longTime = false
          }
          else {
            item.longTime = true
          }
          item.endTime = _that.timeToStr(item.endTime)
          item.startTime = _that.timeToStr(item.startTime)
          dataListSource.push(item)
        })
        dataList = dataListSource
        let totalCount = Math.ceil(parseInt(res.total) / _that.data.pageSize)
        _that.setData({
          dataHistoryList: dataList,
          totalCount: totalCount,
          isNull: false
        })
      }
      else {
        _that.setData({
          isNull: true
        })
      }
    })
  },
  timeToStr(time) {
    if (/-/.test(time)) {
      time = time.replace(/\-/g, "/")
    }
    let timeData = new Date(time)
    let year = timeData.getFullYear()
    let month = timeData.getMonth() + 1
    let date = timeData.getDate()
    let hour = timeData.getHours()
    let minute = timeData.getMinutes()
    return {
      year: year,
      month: month.toString().length > 1 ? month : '0' + month,
      date: date.toString().length > 1 ? date : '0' + date,
      hour: hour.toString().length > 1 ? hour : '0' + hour,
      minute: minute.toString().length > 1 ? minute : '0' + minute,
      yearMonthDate: `${year}年${month.toString().length > 1 ? month : '0' + month}月${date.toString().length > 1 ? date : '0' + date}日`,
      hourMinute: `${hour.toString().length > 1 ? hour : '0' + hour}:${minute.toString().length > 1 ? minute : '0' + minute}`,
      allTime: `${year}-${month.toString().length > 1 ? month : '0' + month}-${date.toString().length > 1 ? date : '0' + date} ${hour.toString().length > 1 ? hour : '0' + hour}:${minute.toString().length > 1 ? minute : '0' + minute}`
    }
  },
  onLoad(query) {
    dd.setNavigationBar({
      title: '历史访客',
    });
    this.setData({
      index: query.index,
      dataHistoryList: []
    })
  },
  visitorInput(event) {
    this.setData({
      value: event.detail.value,
    })
  },
  serchConfirm() {
    const _that = this
    this.setData({
      dataHistoryList: []
    })
    _that.visitorList()

  },
  confirm() {
    const _that = this
    if (_that.data.index == 0) {
      _that.store.data.visitorName = _that.data.select.visitorName
      _that.store.data.visitorPhone = _that.data.select.mobile
      _that.store.data.selectVisitors = false
      _that.update()
    }
    else {
      console.log(_that.store.data.visitorPeer)
      _that.store.data.visitorPeer[_that.data.index - 1].name = _that.data.select.visitorName
      _that.store.data.visitorPeer[_that.data.index - 1].phone = _that.data.select.mobile
      _that.store.data.selectVisitors = false
      _that.update()
    }
    dd.navigateBack({
      delta: 1
    })
  },
  select(event) {
    console.log(event.target.dataset.item.recordId)
    this.setData({
      select: event.target.dataset.item,
      recordId: event.target.dataset.item.recordId
    })
  },
  onReady() {
    this.visitorList(1)
  },
  onShow() {
    // 页面显示
  },
  onHide() {
    // 页面隐藏
  },
  onUnload() {
    // 页面被关闭
  },
  onTitleClick() {
    // 标题被点击
  },
  onReachBottom() {
    let currentNum = '';
    if (this.data.currentPage < this.data.totalCount) {
      currentNum = this.data.currentPage + 1
      this.setData({
        currentPage: currentNum
      })
      this.visitorList(this.data.typeHistory)
    }
  },
  onShareAppMessage() {
    // 返回自定义分享信息
    return {
      title: 'My App',
      desc: 'My App description',
      path: 'pages/index/index',
    };
  },
});
