var app = getApp()
import QR from '../../utils/QRcode';
import $http from '../../API/http';
const aes = require('./../../utils/aeskey.js');
const webSocket = require('./../../utils/socket.js');
let timeRefreshQRcode = '';
Page({
  data: {
    src: './background.png',
    title: '123123123123',
    imgPath: '',
    className: '',
    size: 272,
    url: '',
    ecc: 2,
    isTimeOut: true,
    ma: ''
  },
  onLoad(query) {
    // 页面加载
    const _that = this;
    dd.setNavigationBar({
      title: '付款码'
    });
  },
  // 点击刷新二维码
  clickRefreshQRcode() {
    const _that = this;
    clearInterval(timeRefreshQRcode);
    _that.refreshQRcode();
    timeRefreshQRcode = setInterval(function() {
      _that.refreshQRcode();
    }, 55000);
  },
  // 生成二维码
  refreshQRcode() {
    const _that = this;
    dd.showLoading({
      content: '加载中...'
    });
    let hasToken = dd.getStorageSync({ key: 'token' }).data;
    let token = dd.getStorageSync({ key: 'token' }).data.access_token;
    let expires_in = dd.getStorageSync({ key: 'token' }).data.expires_in;
    let refresh_token = dd.getStorageSync({ key: 'token' }).data.refresh_token;
    let mingUserId = dd.getStorageSync({ key: 'mingUserId' }).data
    if (!!hasToken && (new Date().getTime() - hasToken.loginTime < (hasToken.expires_in - 300) * 1000)) {
      // if(!!hasToken && ((new Date()).getTime() - hasToken.loginTime < 30* 1000)) {
      _that.setData({
        isTimeOut: true
      })
      let timestamp = (new Date()).getTime();
      let url = aes.getAES(JSON.stringify({
        "token": token,
        "timestamp": timestamp,
      })) + `userType:0`
      let size = 272
      let ecc = 2
      let name = 'myQrcode'
      const ctx = dd.createCanvasContext(name);
      QR.draw(url, ctx, size, Number(ecc));
      dd.hideLoading()
    }
    else {
      dd.getNetworkType({
        success: (res => {
          // 网络可用的情况下 刷新token
          if (res.networkAvailable) {
            dd.httpRequest({
              headers: {
                'Authorization': 'Basic bWluZ3BheS1waG9uZTptaW5ncGF5LXBob25l',
                'Content-Type': 'application/x-www-form-urlencoded'
              },
              url: `${app.globalData.globalUrl}/auth/oauth/token`,
              dataType: 'json',
              data: {
                grant_type: 'refresh_token',
                refresh_token: refresh_token
              },
              method: 'POST',
              success: function(res) {
                dd.setStorageSync({
                  key: 'token',
                  data: {
                    access_token: res.data.access_token,
                    expires_in: res.data.expires_in,
                    refresh_token: res.data.refresh_token,
                    loginTime: (new Date()).getTime()
                  }
                })
                dd.hideLoading()
                _that.setData({
                  isTimeOut: true
                })
                let timestamp = (new Date()).getTime();
                let url = aes.getAES(JSON.stringify({
                  "token": res.data.access_token,
                  "timestamp": timestamp,
                }))+ `userType:0`
                let size = 272
                let ecc = 2
                let name = 'myQrcode'
                const ctx = dd.createCanvasContext(name);
                QR.draw(url, ctx, size, Number(ecc));
              },
              fail: function(err) {
                if (err.status == 426) {
                  dd.hideLoading()
                  dd.removeStorageSync({ key: 'token' })
                  dd.redirectTo({
                    url: '/pages/reTry/reTry'
                  })
                }
                else {
                  dd.alert({
                    content: '请检查网络并下拉重试',
                    buttonText: '确定'
                  })
                  _that.setData({
                    isTimeOut: false
                  })
                  dd.hideLoading()
                }
              }
            })
          }
          else {
            dd.alert({
              content: '请检查网络设置并下拉重试',
              buttonText: '确定'
            })
            _that.setData({
              isTimeOut: false
            })
            dd.hideLoading()
          }
        })
      })
    }
  },
  onReady() {
    // 页面加载完成
    // console.log(' onReady')s
    // dd.closeSocket()
  },
  onShow() {
    console.log('进入onshow')
    const _that = this;
    setTimeout(function(res) {
      dd.getNetworkType({
        success: (res) => {
          // 有网络状态
          if (res.networkAvailable) {
            // 获取免登授权码
            webSocket.connectSocket();
            webSocket.onSocketMessageCallback = _that.onSocketMessageCallback;
          }
        }
      });
    },1000)
    //刷新二维码
    setTimeout(function() {
      clearInterval(timeRefreshQRcode);
      _that.refreshQRcode();
      timeRefreshQRcode = setInterval(function() {
        _that.refreshQRcode();
      }, 55000);
    }, 100)
  },
  // socket收到的信息回调
  onSocketMessageCallback: function(res) {
    if (res === 'isHeart!!') {
      console.log(res)
    } else {
      let resData = JSON.parse(res)
      console.log(resData)
      if (resData.paymentCode === 0) {
        // dd.closeSocket();
        dd.navigateTo({
          url: `./../paySuccess/paySuccess?money=${(resData.orderAmount.toFixed(2))}`
        })
      } else if (resData.paymentCode === 10001) {
        dd.alert({
          content: '账户状态异常',
          buttonText: '确定'
        });
      } else if (resData.paymentCode === 10002) {
        dd.alert({
          content: '卡片状态异常',
          buttonText: '确定'
        });
      } else if (resData.paymentCode === 10003) {
        dd.alert({
          content: '账户余额不足',
          buttonText: '确定'
        });
      } else if (resData.paymentCode === 10004) {
        dd.alert({
          content: '二维码失效',
          buttonText: '确定'
        });
      }
    }
  },
  onHide() {
    // 页面隐藏
    clearInterval(timeRefreshQRcode);
  },
  onUnload() {
    // 页面被关闭
    dd.stopPullDownRefresh()
    console.log('onUnload')
    const _that = this;
    clearInterval(timeRefreshQRcode);
    webSocket.closeSocket();
  },
  onTitleClick() {
    // 标题被点击
  },
  onPullDownRefresh() {
    // 页面被下拉
    this.setData({
      src: './background.png',
      title: '123123123123',
      imgPath: '',
      className: '',
      size: 272,
      url: '',
      ecc: 2,
      isTimeOut: true
    })
    const _that = this;
    setTimeout(function() {
      clearInterval(timeRefreshQRcode);
      _that.refreshQRcode();
      timeRefreshQRcode = setInterval(function() {
        _that.refreshQRcode();
      }, 55000);
    }, 100)
    // dd.getNetworkType({
    //   success: (res) => {
    //     // 有网络状态
    //     if (res.networkAvailable) {
    //       // 获取免登授权码
    //       webSocket.connectSocket();
    //       webSocket.onSocketMessageCallback = this.onSocketMessageCallback;
    //     }
    //   }
    // });
    dd.stopPullDownRefresh()
  },
  onReachBottom() {
    // 页面被拉到底部
  },
  onShareAppMessage() {
    // 返回自定义分享信息
    return {
      title: 'My App',
      desc: 'My App description',
      path: 'pages/index/index',
    };
  },
});
