const app = getApp()
import $http from './../../API/http'
import create from 'dd-store'
import exampleStore from '/stores/exampleStore'
create.Page({
  store: exampleStore,
  useAll: true,
  data: {
    currentPage: 1,
    pageSize: 10,
  },

  //  我的访客 公司访客 切换
  changeType(event) {
    this.setData({
      currentPage: 1,
    })
    this.store.data.type = event.target.dataset.type
    this.store.data.dataList = []
    this.update()
    this.store.visitorList(this.data.currentPage, this.data.pageSize, event.target.dataset.type, event.target.dataset.type)
  },
  // 进入访客详情页面
  navigatorToNext(event) {
    dd.navigateTo({ url: `./../visitorsDetail/visitorsDetail?item=${JSON.stringify(event.target.dataset.item)}` })
  },
  // 进入立即预约页面
  appointment() {
    dd.navigateTo({ url: './../reservations/reservations' });
  },
  resetData() {
    this.setData({
      currentPage: 1,
      pageSize: 10,
      todayVisit: 0,
      arrivedVisit: 0
    })
    this.store.data.dataList = []
    this.store.data.type = '1'
    this.update()
  },
  onLoad(query) {
    console.log('进入onLoad')
    this.resetData()
    dd.setNavigationBar({ title: '智能访客' });
    this.store.visitorList(this.data.currentPage, this.data.pageSize, 1, 1)
  },
  onReady() {
  },
  onShow() {
    // 页面显示 兼容iOS 不加延时数据发生改变也不会重新渲染
    const _that = this
    setTimeout(() => {
      _that.update()
    }, 100);
  },
  onHide() {
    // 页面隐藏
  },
  onUnload() {
    // 页面被关闭
  },
  onTitleClick() {
    // 标题被点击
  },
  onReachBottom() {
    let currentNum = '';
    if (this.data.currentPage < this.store.data.totalCount) {
      currentNum = this.data.currentPage + 1
      this.setData({
        currentPage: currentNum
      })
      this.store.visitorList(this.data.currentPage, this.data.pageSize, this.data.type, this.data.type)
    }
  },
  onPullDownRefresh() {
    this.setData({
      currentPage: 1,
      pageSize: 10,
    })
    this.store.data.dataList = []
    this.update()
    this.store.visitorList(this.data.currentPage, this.data.pageSize, this.data.type, this.data.type)
    dd.stopPullDownRefresh()
  },
  onShareAppMessage() {
    // 返回自定义分享信息
    return {
      title: 'My App',
      desc: 'My App description',
      path: 'pages/index/index',
    };
  },
});
