import $http from '../API/http'
class Store {
  data = {
    title: '测试',
    visitorName: '', // 主访客的姓名
    visitorPhone: '',
    selectVisitors: false, //控制遮照层是否层出
    visitorPeer: [], // 同行
    dataList: [], // 访客列表
    isNull: false, // 访客列表是否为空 默认为空
    totalCount: '', // 分页数量
    todayVisit: 0, // 今天的访客
    arrivedVisit: 0, // 已到访的访客
    type: '1', // 默认选中我的访客
  }
  // 访客列表
  visitorList(currentPage, pageSize, type, self) {
    let data = {
      currentPage: currentPage, // 当前页数
      pageSize: pageSize, // 每页几条数据
      type: type // 0: 公司访客 1: 我的访客
    }
    $http.$http('/admin/visitor/getRecordList', data, 'post').then(res => {
      let dataList = res.records;
      console.log(dataList, 'dataList')
      let dataListSource = this.data.dataList;
      if (dataList.length > 0) {
        // overdue 是否过期 overdue==true 代表没有过期 overdue==false 代表过期
        // longTime 预约是否为长期 longTime==true 为长期 longTime==false 为短期
        dataList.forEach((item, index) => {
          if (new Date(item.endTime.replace(/\-/g, "/")).getTime() < new Date().getTime()) {
            item.overdue = true
          }
          else {
            item.overdue = false
          }
          if (new Date(item.endTime.replace(/\-/g, "/")).getTime() - new Date(item.startTime.replace(/\-/g, "/")).getTime() < 24 * 60 * 60 * 3 * 1000) {
            item.longTime = false
          }
          else {
            item.longTime = true
          }
          item.endTime = this.timeToStr(item.endTime)
          item.startTime = this.timeToStr(item.startTime)
          dataListSource.push(item)
        })
        let totalCount = Math.ceil(parseInt(res.total) / pageSize)
        this.data.dataList = dataListSource
        this.data.totalCount = totalCount
        this.data.isNull = false
        this.arriveStaus(self)
        this.update()
      }
      else {
        this.data.dataList = []
        this.data.totalCount = 1
        this.data.isNull = true
        this.data.todayVisit = 0
        this.data.arrivedVisit = 0
        this.update()
      }
    })
  }
  // 处理时间
  timeToStr(time) {
    if (/-/.test(time)) {
      time = time.replace(/\-/g, "/")
    }
    let timeData = new Date(time)
    let year = timeData.getFullYear()
    let month = timeData.getMonth() + 1
    let date = timeData.getDate()
    let hour = timeData.getHours()
    let minute = timeData.getMinutes()
    return {
      year: year,
      month: month.toString().length > 1 ? month : '0' + month,
      date: date.toString().length > 1 ? date : '0' + date,
      hour: hour.toString().length > 1 ? hour : '0' + hour,
      minute: minute.toString().length > 1 ? minute : '0' + minute,
      yearMonthDate: `${year}年${month.toString().length > 1 ? month : '0' + month}月${date.toString().length > 1 ? date : '0' + date}日`,
      hourMinute: `${hour.toString().length > 1 ? hour : '0' + hour}:${minute.toString().length > 1 ? minute : '0' + minute}`,
      allTime: `${year}年${month.toString().length > 1 ? month : '0' + month}月${date.toString().length > 1 ? date : '0' + date}日 ${hour.toString().length > 1 ? hour : '0' + hour}:${minute.toString().length > 1 ? minute : '0' + minute}分`
    }
  }
  // 到访状态
  // 到访的
  arriveStaus(self) {
    let data = {
      type: 0, // type 当月的
      self: self, // 代表公司还是我的访客
    }
    $http.$http('/admin/visitor/getCurrentCount', data, 'post').then(res => {
      this.data.todayVisit = res[1]
      this.data.arrivedVisit = res[0]
      this.update()
    }).catch(err => {
    })

  }


}

export default new Store();